SuperStrict
Framework brl.glmax2d
Import brl.retro
Import brl.pngloader
Import brl.bmploader
Import brl.audio
Import brl.directsoundaudio
Import brl.wavloader

Rem
	This Sourcecode is a MESS! 
EndRem



Const GW:Int = 800
Const GH:Int = 600

AppTitle = "LD25-> Totally Unqualified Getaway Driver [A.Woodard-kerneltrick.com]"

Include "hash.bmx"
Include "mapgen.bmx"
Include "car.bmx"
Include "particles.bmx"
Include "Pedestrian.bmx"
Include "smoker.bmx"

SeedRnd(MilliSecs())


Graphics GW, GH
SetBlend ALPHABLEND
SetVirtualResolution 320 / 2, 240 / 2



Global MX:Int, MY:Int
Global offX:Float, offY:Float

Global CarImg:TImage = LoadAnimImage("img/cars.png", 6, 11, 0, 6, 0)
MidHandleImage CarImg
Global Player:tCar '= New tcar
Global Carslist:TList = CreateList()
Global arrow:TImage = LoadImage(CurrentDir() + "/img/arrow.png", 0)
Global sewer:TImage = LoadImage(CurrentDir() + "/img/sewer.png", 0)
MidHandleImage sewer
MidHandleImage arrow


Global engsound:TSound = LoadSound(CurrentDir() + "/car2.wav", True)'"car2.wav")
Global channel:TChannel = CueSound(engsound)
Global explo:TSound = LoadSound(CurrentDir() + "/explo.wav")
Global EXPchannel:TChannel = CueSound(explo)
Global bexplo:Int = False


Global pedelist:TList = CreateList()

Global Timer:Int


LoadImages

MakeMap

MakeMiniMap

Createplayer

tPed.img = LoadAnimImage(CurrentDir() + "/img/pede.png", 8, 8, 0, 2, 0)
MidHandleImage tPed.img

MakePeds


Function Createplayer()
	Player = New TCar
	Player.positionX = (startloc.x * 64) + 32
	Player.positionY = (startloc.y * 64) + 32
	Player.Bombs = 5
	
	offX = -Player.positionX + 80
	offY = -Player.positionY + 60
	
	Player.Img = Rand(1, 5)

	
End Function

Do_Intro
SetColor 255, 255, 255

ResumeChannel channel


While Not KeyHit(KEY_ESCAPE)
	
	Cls
		MX = MouseX()
		MY = MouseY()
		
		
		bexplo = False
		
		Drawmap
		
		For Local c:tFakeCar = EachIn Carslist
			'c.Update_AI()
			c.update(Player.positionX, Player.positionY)
			c.Update_Collision
			c.draw
		Next
		
		SetOrigin offX, offY
		DrawImage sewer, (endloc.x * 64) + 32, (endloc.y * 64) + 32
		SetOrigin 0, 0
		
		
		Player.Draw()
		
		If KeyHit(KEY_C) Then
			Carslist.AddLast(Create_Cop(Int(Player.positionX) / 64, Int(Player.positiony) / 64))
		EndIf
		
		If KeyDown(KEY_LCONTROL) Then
			If KeyDown(KEY_LEFT) Then offX:+5
			If KeyDown(KEY_RIGHT) Then offX:-5
			If KeyDown(KEY_UP) Then offY:+5
			If KeyDown(KEY_DOWN) Then offY:-5
		Else
			Player.ControlViaKeys
		EndIf
		
		Player.UpdatePhysics
		
		Player.update_Collision
		
		offX = -Player.positionX + 80
		offY = -Player.positionY + 60
		
		
	'	DrawText Int(Player.positionX) / 64, 10, 10
	'	DrawText Int(Player.positionX) Mod 64, 10, 20
	'	DrawText Player.Damage, 10, 10
	'	DrawText Player.pRate, 10, 20
	'	DrawText Max(Player.velocityX, Player.velocityY), 10, 30
	'	DrawText bexplo, 0, 0
	
	
		For Local p:tPed = EachIn pedelist
			p.update Player.positionX, Player.positionY
			p.draw
		Next
		
		
		If bexplo = True Then
			StopChannel EXPchannel
			
			 PlaySound(explo, EXPchannel)  'If Timer Mod 2 = 0 Then
		EndIf
		
		
		Local xx:Float, yy:Float, aa:Float
		aa = AngleTO(endloc.x * 64, endloc.y * 64, Player.positionX, Player.positionY) + 180 + 90
		xx = 80 + (Sin(aa) * 20)
		yy = 60 + (Cos(aa) * 20)
		SetOrigin 0, 0
		SetRotation aa
		DrawImage arrow, xx, yy
		SetRotation 0
		SetColor 0, 32, 0
		DrawRect 5, 5, 50, 5
		SetColor 0, 255, 0
		DrawRect 5, 5, (100 - Player.Damage) / 2, 5
		
		If Timer Mod 4 = 0 Then
			SetChannelRate channel, Player.pRate
		EndIf
		
		If Timer < 30 * 4 Then
			Show_Goal()
		EndIf
		
		Timer:+1
	Flip
Wend

Function Drawmap()
	SetColor 255, 255, 255
	SetOrigin offX, offY
	'SetScale 2, 2
	For Local x:Int = 0 Until tRoadMap.W
		For Local y:Int = 0 Until tRoadMap.H
			If RoadMapImg[x, y] Then
				'If Int(Player.positionX) / 64 = x And Int(Player.positionY) / 64 = y Then
				'	SetColor 64, 64, 64
				'EndIf
				DrawImage(RoadMapImg[x, y], x * 64, y * 64)
				SetColor 255, 255, 255
			EndIf
		Next
	Next
	
	SetOrigin 0, 0
	
	'SetScale 0.5, 0.5
	If Not KeyDown(KEY_M) Then Return
	
	DrawImage MiniMap, 0, 0
	
	SetColor 0, 0, 255
	DrawRect startloc.x, startloc.y, 1, 1
	
	SetColor 255, 0, 0
	DrawRect endloc.x, endloc.y, 1, 1
	
	SetColor 0, 255, 0
	DrawRect Player.positionX / 64, Player.positionY / 64, 1, 1

	
	SetColor 255, 255, 255
	
	SetScale 1, 1
End Function


Function Do_Intro()
	Local logo:TImage = LoadImage(CurrentDir() + "/img/logo.png", 0)
	If Not logo Then RuntimeError("cant find image")
	
	While True
		Cls
			DrawImage(logo, 0, 0)
			
			If KeyHit(KEY_SPACE) Then Return
			If KeyHit(KEY_ESCAPE) Then End
			Local c:Int = Rand(128, 240)
			SetColor c + Rand(-15, 15), c + Rand(-15, 15), c + Rand(-15, 15)
			
		Flip
	WEnd
End Function

Function Do_Lose()
	Local lose:TImage = LoadImage(CurrentDir() + "/img/end.png", 0)
	If Not lose Then RuntimeError("cant find image")
	
	channel.Stop
	
	SetChannelRate(EXPchannel, 0.2)
	PlaySound(explo, EXPchannel)
	
	While True
		Cls
			DrawImage(lose, 0, 0)
			
			'If KeyHit(KEY_SPACE) Then Return
			If KeyHit(KEY_ESCAPE) Then End
			Local c:Int = Rand(128, 240)
			'SetColor c + Rand(-15, 15), c + Rand(-15, 15), c + Rand(-15, 15)
			DrawText("You Lose!", 30 + Rand(3), 10 + Rand(3))
		Flip
	WEnd
End Function


Function Do_WIN()
	Local win:TImage = LoadImage(CurrentDir() + "/img/win.png", 0)
	If Not win Then RuntimeError("cant find image")
	
	channel.Stop
	
	While True
		Cls
			SetColor 255, 255, 255
			DrawImage(win, 0, 0)
			
			'If KeyHit(KEY_SPACE) Then Return
			If KeyHit(KEY_ESCAPE) Then End
			Local c:Int = Rand(128, 240)
			SetColor 0, c + Rand(-15, 15), 0
			DrawText("You escaped!", 10, 10)
		Flip
	WEnd
End Function	

Function Show_Goal()
	SetColor 255, 0, 0
	DrawText "We got the money!", 0, 10
	DrawText "Get to the Sewer!", 0, 20
	SetColor 255, 255, 255
End Function

