

Type tSmoker
	Global img:TImage
	 
	Field x:Int, y:Int
	Field start:Int
	Field interval:Int
	Field frame:Int = 0
	
	Method New()
		interval = Rand(5, 20)
		If Not img Then
			img = LoadAnimImage(CurrentDir() + "/img/smk.png", 8, 8, 0, 4, 0)
			MidHandleImage img
		EndIf
	End Method
	
	Function Create:tsmoker(x:Float, y:Float)
		Local s:tSmoker = New tSmoker
		s.x = x
		s.y = y
		s.start = Timer
		Return s
	End Function
	
	Method update:Int(X:Int, Y:Int)
		If Timer Mod interval = 0 Then
			frame:+1
			Self.X = X
			Self.Y = Y
			If frame > 3 Then frame = 0
			Return True
		EndIf
		Return False
	End Method
	
	Method draw()
		SetOrigin offX, offY
		SetScale 2, 2
		DrawImage img, x, y, frame
		SetScale 1, 1
	End Method
	
End Type